
package de.ivu.elect.presentation.auffaelligkeit.action;

import javax.annotation.Nonnull;
import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.gebietsbaum.boundary.GebietSessionSelect;
import de.ivu.elect.business.gebietsbaum.entity.Gebiet;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.stimmeingabe.entity.StimmeingabeAuffaelligkeit;
import de.ivu.elect.presentation.menu.AbstractActionEntry;
import de.ivu.elect.presentation.security.AbstractGebietSecurity;
import de.ivu.elect.presentation.stimmeingabe.StimmeingabeErfassenViewResolver;

@Named(StimmeingabeAuffaelligkeitEditAction.COMPONENT_NAME)
public class StimmeingabeAuffaelligkeitEditAction extends AbstractActionEntry<StimmeingabeAuffaelligkeit> {

  public static final String COMPONENT_NAME = "stimmeingabeAuffaelligkeitEditAction";

  private static final long serialVersionUID = 1L;

  @Inject
  private transient GebietSessionSelect gebietSelect;

  @Inject
  private transient StimmeingabeErfassenViewResolver stimmeingabeErfassenViewResolver;

  public StimmeingabeAuffaelligkeitEditAction() {
    super();
  }

  @Override
  protected UseCasePermission getRequiredPermission() {
    return stimmeingabeErfassenViewResolver.getViewIdPermission();
  }

  @Override
  protected AbstractGebietSecurity getGebietSecurity() {
    return getEinsehenGebietSecurity();
  }

  @Override
  public boolean isDisabledInternal(@Nonnull StimmeingabeAuffaelligkeit stimmeingabeAuffaelligkeit) {
    return false;
  }

  @Override
  protected String doIt(StimmeingabeAuffaelligkeit stimmeingabeAuffaelligkeit) {
    if (stimmeingabeAuffaelligkeit == null) {
      return null;
    }

    Gebiet gebiet = stimmeingabeAuffaelligkeit.getGebiet();

    if (gebiet == null) {
      return null;
    }

    gebietSelect.setEntity(gebiet);

    return stimmeingabeErfassenViewResolver.getViewId();
  }

  @Override
  protected boolean isFireChangeEvent() {
    return false;
  }

  @Override
  protected void fireChangeEvent() {
    // nichts zu tun
  }

  @Override
  public String getLabelKey() {
    return "stimmeingabe.erfassen.menu.item.label";
  }

  @Override
  public String getIcon() {
    return appIcons.getIconEdit();
  }
}
